



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Guava文档翻译之ListenableFuture</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Guava文档翻译之ListenableFuture</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 19:48:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1><a href="https://github.com/google/guava/wiki/ListenableFutureExplained" rel="external nofollow noreferrer">ListenableFutureExplained</a></h1>
<p>并发是一个困难的问题，但是使用强大而简单的抽象可以极大地简化并发问题。为了简化事情，Guava使用<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/ListenableFuture.html" rel="external nofollow noreferrer"><code>ListenableFuture</code></a>继承了JDK的Future接口.</p>
<p>我们强烈建议你在所在代码里总是使用ListenableFuture，而不是Future，因为：</p>
<ul><li>大多数Future相关的接口需要它</li>
<li>这比以后换成ListenableFuture更容易</li>
<li>工具的提供者不需要为它们的方法分别提供Future和ListenableFuture的变体</li></ul>
<h1>接口 Interface</h1>
<p>一个传统的Future代表一个异步计算的结果：一个可能已经得到结果或者还没结束的计算。一个Future可以作为一个正在进行中的计算的句柄(handle), 作为一个服务对我们的保证(promise)，保证它会提供给我们一个结果。</p>
<p>一个ListenableFuture允许我们注册一个在计算完成时会执行的回调(callback)，如果计算已经完成，就会立即执行回调。这个增加的简单功能可以让ListenableFuture支持很多基本的Future接口所不支持的操作。</p>
<p>ListenableFuture所增加的基本操作是<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/ListenableFuture.html#addListener(java.lang.Runnable,%20java.util.concurrent.Executor)" rel="external nofollow noreferrer"><code>addListener(Runnable, Executor)</code></a>, 它指明当这个Future代表的计算完成时，特定的Runnable将会在特定的Executor中执行。</p>
<h1>填加回调 Adding Callbacks</h1>
<p>大多数用户倾向于使用<code><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#addCallback(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.util.concurrent.FutureCallback,%20java.util.concurrent.Executor)" rel="external nofollow noreferrer">Futures.addCallback(ListenableFuture&lt;V&gt;, FutureCallback&lt;V&gt;, Executor)</a>，或者另一个默认使用MoreExecutors.sameThreadExecutor的<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#addCallback(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.util.concurrent.FutureCallback)" rel="external nofollow noreferrer">版本</a>，来在回调执行快速并且轻量的时候使用。一个需要实现两个方法&nbsp;<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/FutureCallback.html" rel="external nofollow noreferrer"><code>FutureCallback&lt;V&gt;</code></a>：</code></p>
<ul><li><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/FutureCallback.html#onSuccess(V)" rel="external nofollow noreferrer"><code>onSuccess(V)</code></a>，在future成功时执行的动作，基于future的结果。</li>
<li><code><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/FutureCallback.html#onFailure(java.lang.Throwable)" rel="external nofollow noreferrer">onFailure(Throwable)</a>，</code>当future失败时执行的动作，基于失败的原因。</li></ul>
<h1>创建 Creation</h1>
<p>与JDK使用<a href="http://docs.oracle.com/javase/1.5.0/docs/api/java/util/concurrent/ExecutorService.html#submit(java.util.concurrent.Callable)" rel="external nofollow noreferrer"><code>ExecutorService.submit(Callable)</code></a>的方式来初始化一个异步的计算相类似，Guava提供了接口<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/ListeningExecutorService.html" rel="external nofollow noreferrer"><code>ListeningExecutorService</code></a>，它会返回一个ListenableFuture而不像ExecutorService那样返回一个Future。如果想要把一个ExecutorService转化为一个ListeningExecutorService，只需要使用MoreExecutors.listeningDecorator(ExecutorService)。</p>
<div>
<pre class="prettyprint linenums">ListeningExecutorService service = MoreExecutors.listeningDecorator(Executors.newFixedThreadPool(10));<br />
ListenableFuture&lt;Explosion&gt; explosion = service.submit(new Callable&lt;Explosion&gt;() {<br />
  public Explosion call() {<br />
    return pushBigRedButton();<br />
  }<br />
});<br />
Futures.addCallback(explosion, new FutureCallback&lt;Explosion&gt;() {<br />
  // we want this handler to run immediately after we push the big red button!<br />
  public void onSuccess(Explosion explosion) {<br />
    walkAwayFrom(explosion);<br />
  }<br />
  public void onFailure(Throwable thrown) {<br />
    battleArchNemesis(); // escaped the explosion!<br />
  }<br />
});</pre>
</div>
<p>或者，如果你之前用的是基于<a href="http://docs.oracle.com/javase/1.5.0/docs/api/java/util/concurrent/FutureTask.html" rel="external nofollow noreferrer"><code>FutureTask</code></a>的API，Guava提供了<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/ListenableFutureTask.html#create(java.util.concurrent.Callable)" rel="external nofollow noreferrer"><code>ListenableFutureTask.create(Callable&lt;V&gt;)</code></a>&nbsp;以及<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/ListenableFutureTask.html#create(java.lang.Runnable,%20V)" rel="external nofollow noreferrer"><code>ListenableFutureTask.create(Runnable, V)</code></a>。不像JDK，ListenableFutureTask并不是用来直接继承的。</p>
<p>如果你想要这样的抽象：你想直接设置future的值，而不是实现一个方法来计算这个值，考虑下继承&nbsp;<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/AbstractFuture.html" rel="external nofollow noreferrer"><code>AbstractFuture&lt;V&gt;</code></a>&nbsp;，或者直接使用<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/SettableFuture.html" rel="external nofollow noreferrer"><code>SettableFuture</code></a>。</p>
<p>如果你必须把其它API提供的Future转成ListenableFuture，你可能别无选择，而必须使用重量级&nbsp;<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/JdkFutureAdapters.html" rel="external nofollow noreferrer"><code>JdkFutureAdapters.listenInPoolThread(Future)</code></a>的来把一个Future转成ListenableFuture. 只要情况允许，更好的选择就是修改原来的代码，让它返回一个ListenableFuture。</p>
<h1>应用 Application</h1>
<p>(译注：这个application应该理解成apply的名词，是'apply a function to a value'里的apply的意思, 请从函数式编程的角度理解)</p>
<p>使用ListenableFuture的最主要的原因是，它可以组成异步操作的复杂的处理链。</p>
<div>
<pre class="prettyprint linenums">ListenableFuture&lt;RowKey&gt; rowKeyFuture = indexService.lookUp(query);<br />
AsyncFunction&lt;RowKey, QueryResult&gt; queryFunction =<br />
  new AsyncFunction&lt;RowKey, QueryResult&gt;() {<br />
    public ListenableFuture&lt;QueryResult&gt; apply(RowKey rowKey) {<br />
      return dataService.read(rowKey);<br />
    }<br />
  };<br />
ListenableFuture&lt;QueryResult&gt; queryFuture = Futures.transform(rowKeyFuture, queryFunction, queryExecutor);</pre>
</div>
<p>(译注：如果懂Scala的话，这段代码大体相当于rowKeyFuture.<a href="http://www.scala-lang.org/api/2.10.3/index.html#scala.concurrent.Future" rel="external nofollow noreferrer">map</a>(dataService.read)(queryExecutor), 要短了非常多，也更好理解。但是Scala的Future好像不像ListenableFuture可以注册多个监听器)</p>
<p>有很多其它的操作也可以被ListenableFuture高效的支持，但是Future就不行。不同的操作可以在不同的executor中执行，一个ListenableFuture也可以有多个等待执行的动作。</p>
<p>当很多个操作都要在另一个操作开始后立即执行--也就是扇出(fan-out)--ListenableFuture可以做到这点：它可以触发所有那些的需要执行的回调。多做一点工作，我们就可以扇入(fan-in)，或者触发一个ListenableFuture，在其它所有的Future都完成以后，它会立即执行: 一个例子是<a href="http://google.github.io/guava/releases/snapshot/api/docs/src-html/com/google/common/util/concurrent/Futures.html#line.1276" rel="external nofollow noreferrer">the implementation of&nbsp;<code>Futures.allAsList</code></a></p>
<table>
<thead>
<tr>
<th>Method</th>
<th>Description</th>
<th>See also</th>
</tr>
</thead>
<tbody>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.util.concurrent.AsyncFunction,%20java.util.concurrent.Executor)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, AsyncFunction&lt;A, B&gt;, Executor)</code></a><code>*</code></td>
<td>Returns a new<code>ListenableFuture</code>whose result is the product of applying the given<code>AsyncFunction</code>&nbsp;to the result of the given<code>ListenableFuture</code>.</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.util.concurrent.AsyncFunction)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, AsyncFunction&lt;A, B&gt;)</code></a></td>
</tr>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.base.Function,%20java.util.concurrent.Executor)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, Function&lt;A, B&gt;, Executor)</code></a></td>
<td>Returns a new<code>ListenableFuture</code>whose result is the product of applying the given&nbsp;<code>Function</code>to the result of the given<code>ListenableFuture</code>.</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.base.Function)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, Function&lt;A, B&gt;)</code></a></td>
</tr>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#allAsList(java.lang.Iterable)" rel="external nofollow noreferrer"><code>allAsList(Iterable&lt;ListenableFuture&lt;V&gt;&gt;)</code></a></td>
<td>Returns a<code>ListenableFuture</code>whose value is a list containing the values of each of the input futures, in order. If any of the input futures fails or is cancelled, this future fails or is cancelled.</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#allAsList(com.google.common.util.concurrent.ListenableFuture...)" rel="external nofollow noreferrer"><code>allAsList(ListenableFuture&lt;V&gt;...)</code></a></td>
</tr>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#successfulAsList(java.lang.Iterable)" rel="external nofollow noreferrer"><code>successfulAsList(Iterable&lt;ListenableFuture&lt;V&gt;&gt;)</code></a></td>
<td>Returns a<code>ListenableFuture</code>whose value is a list containing the values of each of the successful input futures, in order. The values corresponding to failed or cancelled futures are replaced with&nbsp;<code>null</code>.</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#successfulAsList(com.google.common.util.concurrent.ListenableFuture...)" rel="external nofollow noreferrer"><code>successfulAsList(ListenableFuture&lt;V&gt;...)</code></a></td>
</tr>
</tbody>
</table>
<table>
<thead>
<tr>
<th>Method 方法</th>
<th>Description 描述</th>
<th>See also 参见</th>
</tr>
</thead>
<tbody>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.util.concurrent.AsyncFunction,%20java.util.concurrent.Executor)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, AsyncFunction&lt;A, B&gt;, Executor)</code></a><code>*</code></td>
<td>
<p>Returns a new<code>ListenableFuture&nbsp;</code>whose result is the product of applying the given&nbsp;<code>AsyncFunction</code>&nbsp;to the result of the given&nbsp;<code>ListenableFuture</code>.</p>
<p>返回一个新的ListenableFuture, 它的结果是把给定的ListenableFuture的结果应用于给定的异步函数的结果(译注：意思是把给定的ListenableResult的result作为参数调用给定的异步函数)</p>
</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.util.concurrent.AsyncFunction)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, AsyncFunction&lt;A, B&gt;)</code></a></td>
</tr>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.base.Function,%20java.util.concurrent.Executor)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, Function&lt;A, B&gt;, Executor)</code></a></td>
<td>
<p>Returns a new&nbsp;<code>ListenableFuture&nbsp;</code>whose result is the product of applying the given&nbsp;<code>Function</code>to the result of the given&nbsp;<code>ListenableFuture</code>.</p>
<p>返回一个新的ListenableFuture，它的结果是把给定的ListenableFuture的结果应用于给定的函数的结果</p>
</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#transform(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.base.Function)" rel="external nofollow noreferrer"><code>transform(ListenableFuture&lt;A&gt;, Function&lt;A, B&gt;)</code></a></td>
</tr>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#allAsList(java.lang.Iterable)" rel="external nofollow noreferrer"><code>allAsList(Iterable&lt;ListenableFuture&lt;V&gt;&gt;)</code></a></td>
<td>
<p>Returns a&nbsp;<code>ListenableFuture&nbsp;</code>whose value is a list containing the values of each of the input futures, in order. If any of the input futures fails or is cancelled, this future fails or is cancelled.</p>
<p>返回一个新的ListenableFuture，它的结果一个list, 这个list包括了给定的一系列ListenableFuture的结果，list的元素按照这些给定的ListenableFuture的顺序。如果给定的这些futures中有任何一个被取消了或者失败了，被返回的这个ListenableFuture就会被取消或失败。</p>
</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#allAsList(com.google.common.util.concurrent.ListenableFuture...)" rel="external nofollow noreferrer"><code>allAsList(ListenableFuture&lt;V&gt;...)</code></a></td>
</tr>
<tr>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#successfulAsList(java.lang.Iterable)" rel="external nofollow noreferrer"><code>successfulAsList(Iterable&lt;ListenableFuture&lt;V&gt;&gt;)</code></a></td>
<td>
<p>Returns a<code>ListenableFuture</code>whose value is a list containing the values of each of the successful input futures, in order. The values corresponding to failed or cancelled futures are replaced with&nbsp;<code>null</code>.</p>
<p>返回一个新的ListenableFuture，它的值是一个list,这个list包括了每一个成功执行的future，按照给出的顺序。跟失败或者被取消的future相关的值会被设成null</p>
</td>
<td><a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#successfulAsList(com.google.common.util.concurrent.ListenableFuture...)" rel="external nofollow noreferrer"><code>successfulAsList(ListenableFuture&lt;V&gt;...)</code></a></td>
</tr>
</tbody>
</table>
<p><code>*</code>&nbsp;An&nbsp;<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/AsyncFunction.html" rel="external nofollow noreferrer"><code>AsyncFunction&lt;A, B&gt;</code></a>&nbsp;provides one method,&nbsp;<code>ListenableFuture&lt;B&gt; apply(A input)</code>. It can be used to asynchronously transform a value.</p>
<p>一个提供了一个方法<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/AsyncFunction.html" rel="external nofollow noreferrer"><code>AsyncFunction&lt;A, B&gt;</code></a>，ListenableFuture&lt;B&gt; apply(A input)。它可以被用于异步地转换一个值。</p>
<div>
<pre class="prettyprint linenums">List&lt;ListenableFuture&lt;QueryResult&gt;&gt; queries;<br />
// The queries go to all different data centers, but we want to wait until they're all done or failed.

ListenableFuture&lt;List&lt;QueryResult&gt;&gt; successfulQueries = Futures.successfulAsList(queries);

Futures.addCallback(successfulQueries, callbackOnSuccessfulQueries);</pre>
</div>
<h1>CheckedFuture</h1>
<p>Guava也提供了一个<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/CheckedFuture.html" rel="external nofollow noreferrer"><code>CheckedFuture&lt;V, X extends Exception&gt;</code></a>接口。一个CheckedFuture 也是一个ListenableFuture，包括了各种版本的可以抛出受检异常的方法。这使得创建一个执行逻辑可能抛出异常的Future更加容易。如果想要把一个ListenableFuture转成一个CheckedFuture， 可以使用<a href="http://google.github.io/guava/releases/snapshot/api/docs/com/google/common/util/concurrent/Futures.html#makeChecked(com.google.common.util.concurrent.ListenableFuture,%20com.google.common.base.Function)" rel="external nofollow noreferrer"><code>Futures.makeChecked(ListenableFuture&lt;V&gt;, Function&lt;Exception, X&gt;)</code></a>.</p>
<hr />
<p>总结：</p>
<p>ListenableFuture提供了很有价值的对JDK并发库的补充。不过同样的功能，Scala提供的Future的功能要更强大，而且Scala的语法也使得代码更简单易懂。实际上，Promise也是很强大的一种抽象，这篇Guava的文章只简单提了一下SettableFuture。想要更深入了解的可以看一下Scala的文档，这个有人翻译了，页面的右上角可以选择中文版。</p>
<h1><a href="http://docs.scala-lang.org/overviews/core/futures.html" rel="external nofollow noreferrer">Futures and Promises</a></h1>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq44gjjq.html">python对Mysql操作和使用ORM框架（SQLAlchemy）</a>
		</li>
						<li><a href="https://www.batexi.com/a/390jmlm8.html">python学习道路&lpar;day10note&rpar;&lpar;线程，进程&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mwwm0q.html">shell单引号中输出参数值</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pvxmd9.html">MySQL 调优基础&lpar;二&rpar; Linux内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/m962onvq.html">安装CocoaPods报错 - &lbrack;&excl;&rsqb; The dependency &grave;AFNetworking &lpar;~&amp;gt&semi; 3&period;1&period;0&rpar;&grave; is not used in any concrete target&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mody09.html">OpenFlow&period;p4 源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdkno38.html">30个深度学习库：按Python、C&plus;&plus;、Java、JavaScript、R等10种语言分类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okn3v19.html">PHP用正则批量替换Img中src内容&comma;用正则表达式获取图片路径实现缩略图功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmjpmx9.html">iOS-NSThread使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v46xn8.html">Xcode常用设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1plkx9.html">&lbrack;FTP&rsqb; FTPHelper－FTP帮助类&comma;常用操作方法 （转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdovj78.html">QF&mdash;&mdash;OC数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdn5nz9.html">北京创客空间 BEIJING MAXPACE的小站</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p4vxj8.html">python3基础&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megm26q.html">Redtiger  SQL注入练习（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1nzm5q.html">ASP中替换掉换行符&amp;lt&semi;br&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwj5oy8.html">C语言堆栈入门&mdash;&mdash;堆和栈的区别（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll1rxq.html">画PCB</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy54j19.html">（转）注解用法详解&mdash;&commat;&commat;SuppressWarnings</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvez1xx9.html">python接口自动化-参数化</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwd0mxl8.html">8套迷人精致的CSS3 3D按钮动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeoy709.html">mysql安装过程中出现的错误问题解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w0zo3q.html">C&plus;&plus;封装常用对象和对头文件以及预编译机制的探索</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjxlmk9.html">c&plus;&plus;11&colon;iota</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k15xm69.html">关于getpw系列函数返回的静态区域</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1jd319.html">解决nginx负载均衡的session共享问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydrp6mq.html">jQuery之&dollar;&lpar;document&rpar;&period;ready&lpar;&rpar;使用介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w07dxq.html">java 语法糖</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj3nmd9.html">perl中shift 和unshift 操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd1d5e8.html">DRP PK 牛腩新闻发布系统</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
